program FindHandler;
{$M 2048,0,655360}
uses
   DOS, Hex;

const
   VStr =          '1.1';

type
   PPointer =      ^Pointer;

   PList =         ^TList;
   TList =
   record
      Next         :PList;
      Handler      :Pointer;
   end;

var
   IntNumS         :String[3];
   IntNum          :LongInt;
   Error           :Integer;
   Handler, Next,
   NextPtr         :Pointer;
   Offset          :Word;
   Old, New        :Byte;
   ROM, WasROM,
   Sure            :Boolean;
   Method          :PChar;

const
   List            :PList =  nil;
var
   Current         :PList;

function  CheckHandler(Handler         :Pointer) :Boolean;
begin
   CheckHandler:=
      (Ofs(Handler^)<>Seg(Handler^)) and
      (Ofs(Handler^)<$FFFF) and
      ((Word(Handler^)<>Word((Pointer(PChar(Handler)+2))^)) or (Word(NextPtr^)=$9090));
end;

begin
   Write(#13#10+
      'FindROM  Version '+VStr+'  Copyright (c) 1995 by Solar Designer \ BPC'#13#10+
      #13#10+
      'Enter interrupt number (hex) :');
   ReadLn(IntNumS);
   WriteLn;

   Val('$'+IntNumS, IntNum, Error);
   if (Error<>0) or (IntNum and $FFFFFF00<>0) then
   begin
      WriteLn('Invalid interrupt number'); Halt;
   end;

   GetIntVec(Byte(IntNum), Handler);

   WasROM:=False; Sure:=True; Method:='1st Handler';
   repeat
      Current:=List;
      while (Current<>nil) and (Current^.Handler<>Handler) do
         Current:=Current^.Next;
      if Current<>nil then Break;

      System.New(Current);
      Current^.Handler:=Handler;
      Current^.Next:=List;
      List:=Current;

      asm cli end;
      Old:=Byte(Handler^); New:=not Old;
      Byte(Handler^):=New;
      ROM:=(Byte(Handler^)=Old);
      Byte(Handler^):=Old;
      asm sti end;

      if WasROM and (not ROM) then Break;
      WasROM:=ROM;

      Write('Handler @', HexPointer(Handler));
      if Sure then Write(' !') else Write(' ?');
      if ROM then Write(' ROM  ') else Write(' RAM  ');
      Write(Method);

      if not CheckHandler(Handler) then
      begin
         WriteLn('; no code'); Break;
      end;

      WriteLn;

      if (Byte(Handler^)=$CF) or (Byte(Handler^)=$CB) then Break;

      Next:=nil;
      for Offset:=0 to $11FF do
      begin
         if Ofs(Handler^)>$FFFF-5 then Break;

         if (Word(Handler^)=$1EFF) or (Word(Handler^)=$2EFF) then
         begin
            NextPtr:=Pointer(Ptr(Seg(Handler^), Word((Pointer(PChar(Handler)+2))^))^);
            if CheckHandler(NextPtr) then
            begin
               Next:=NextPtr;
               Sure:=True;

               if Word(Handler^)=$1EFF
               then Method:='Call DWord Ptr'
               else Method:='Jump DWord Ptr';

               Break;
            end;
         end;

         if ((Next=nil) and ((Byte(Handler^)=$9A) or (Byte(Handler^)=$EA))) or
            (Word(Handler^)=$9A9C) then
         begin
            NextPtr:=PPointer(PChar(Handler)+1)^;
            if CheckHandler(NextPtr) then
            begin
               Next:=NextPtr;
               Sure:=(Byte(Handler^)=$9C);

               if Sure then Method:='PushF / Call Far' else
               if Byte(Handler^)=$9A
               then Method:='Call Far'
               else Method:='Jump Far';

               Sure:=Sure or (Offset=0);
               if Sure then Break;
            end;
         end;

         if (Offset>$FF) and (Next<>nil) then Break;

         Inc(PChar(Handler));
      end;

      Handler:=Next;
   until Next=nil;
end.

